/*
 *  upkg: tool for manipulating Unreal Tournament packages.
 *  Copyright (C) 2009 Nick Bowler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef EXPORTABLE_H_
#define EXPORTABLE_H_

#include <stdio.h>
#include <glib-object.h>

#define U_OBJECT_TYPE_EXPORTABLE (u_object_exportable_get_type())
#define U_OBJECT_EXPORTABLE(obj) G_TYPE_CHECK_INSTANCE_CAST(obj, \
	U_OBJECT_TYPE_EXPORTABLE, UObjectExportable)
#define U_OBJECT_IS_EXPORTABLE(obj) G_TYPE_CHECK_INSTANCE_TYPE(obj, \
	U_OBJECT_TYPE_EXPORTABLE)
#define U_OBJECT_EXPORTABLE_GET_INTERFACE(inst) G_TYPE_INSTANCE_GET_INTERFACE \
	(inst, U_OBJECT_TYPE_EXPORTABLE, UObjectExportable)

typedef struct UObjectExportable UObjectExportable;

struct UObjectExportable {
	GTypeInterface parent;

	int (*export)(GObject *obj, FILE *f);
	int (*export_name)(GObject *obj, char *buf, size_t n);
};

GType u_object_exportable_get_type(void);

int u_object_export(GObject *obj, FILE *f);
int u_object_export_name(GObject *obj, char *buf, size_t n);

#endif
