/*
 *  upkg: tool for manipulating Unreal Tournament packages.
 *  Copyright (C) 2009 Nick Bowler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef PACK_H_
#define PACK_H_

#include <limits.h>

void pack_16_be(unsigned char *, unsigned short);
void pack_32_be(unsigned char *, unsigned long);
#ifdef ULLONG_MAX
void pack_64_be(unsigned char *, unsigned long long);
#endif

void pack_16_le(unsigned char *, unsigned short);
void pack_32_le(unsigned char *, unsigned long);
#ifdef ULLONG_MAX
void pack_64_le(unsigned char *, unsigned long long);
#endif

unsigned short unpack_16_be(unsigned char *);
unsigned long  unpack_32_be(unsigned char *);
#ifdef ULLONG_MAX
unsigned long long unpack_64_be(unsigned char *);
#endif

unsigned short unpack_16_le(unsigned char *);
unsigned long  unpack_32_le(unsigned char *);
#ifdef ULLONG_MAX
unsigned long long unpack_64_le(unsigned char *);
#endif

short unpack_s16_be(unsigned char *);
long  unpack_s32_be(unsigned char *);
#ifdef LLONG_MAX
long long unpack_s64_be(unsigned char *);
#endif

short unpack_s16_le(unsigned char *);
long  unpack_s32_le(unsigned char *);
#ifdef LLONG_MAX
long long unpack_s64_le(unsigned char *);
#endif

#endif
